use axum::Router;

pub use inventory::submit;

pub trait RouteMethod: Send + Sync + 'static {
    fn ge_router(&self, router: Router) -> Router;
}

inventory::collect!(&'static dyn RouteMethod);

#[macro_export]
macro_rules! submit_router_method {
    ($ty:ident) => {
        ::library::task::submit! {
            &$ty as &dyn ::library::typed_router::RouteMethod
        }
    };
}

pub fn get_router() -> Router {
    let mut router = Router::new();
    for method in inventory::iter::<&dyn RouteMethod> {
        // result.push(Arc::new(method.ge_task()));
        router = method.ge_router(router);
    }
    router
}